Index: libstdc++-v3/testsuite/23_containers/unordered_multiset/final_hash.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/unordered_multiset/final_hash.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/23_containers/unordered_multiset/final_hash.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -10,7 +10,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/23_containers/unordered_multiset/range_access.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/unordered_multiset/range_access.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/23_containers/unordered_multiset/range_access.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -10,7 +10,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/23_containers/unordered_multiset/observers.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/unordered_multiset/observers.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/23_containers/unordered_multiset/observers.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -10,7 +10,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/23_containers/map/range_access.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/map/range_access.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/23_containers/map/range_access.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -10,7 +10,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/23_containers/map/capacity/29134.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/map/capacity/29134.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/23_containers/map/capacity/29134.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -7,7 +7,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/23_containers/array/range_access.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/array/range_access.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/23_containers/array/range_access.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -10,7 +10,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/23_containers/array/element_access/at_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/array/element_access/at_neg.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/23_containers/array/element_access/at_neg.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -10,7 +10,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/20_util/make_signed/requirements/typedefs-2.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/make_signed/requirements/typedefs-2.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/20_util/make_signed/requirements/typedefs-2.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,5 +1,5 @@
 // { dg-options "-std=gnu++0x -funsigned-char -fshort-enums" }
-// { dg-options "-std=gnu++0x -funsigned-char -fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi } }
+// { dg-options "-std=gnu++0x -funsigned-char -fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi* } }
 
 // 2007-05-03  Benjamin Kosnik  <bkoz@redhat.com>
 //
Index: libstdc++-v3/testsuite/20_util/make_unsigned/requirements/typedefs-2.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/make_unsigned/requirements/typedefs-2.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/20_util/make_unsigned/requirements/typedefs-2.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,5 +1,5 @@
 // { dg-options "-std=gnu++0x -funsigned-char -fshort-enums" }
-// { dg-options "-std=gnu++0x -funsigned-char -fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi } }
+// { dg-options "-std=gnu++0x -funsigned-char -fshort-enums -Wl,--no-enum-size-warning" { target arm*-*-linux*eabi* } }
 
 // 2007-05-03  Benjamin Kosnik  <bkoz@redhat.com>
 //
Index: libstdc++-v3/testsuite/20_util/shared_ptr/cons/55123.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/shared_ptr/cons/55123.cc	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ libstdc++-v3/testsuite/20_util/shared_ptr/cons/55123.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,28 @@
+// { dg-options "-std=gnu++0x" }
+// { dg-do compile }
+
+// Copyright (C) 2012 Free Software Foundation
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#include <memory>
+
+// libstdc++/55123
+
+void f() {
+  std::unique_ptr<const int> y;
+  std::shared_ptr<const int> x = std::move(y);
+}
Index: libstdc++-v3/testsuite/20_util/function/cons/55320.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/function/cons/55320.cc	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ libstdc++-v3/testsuite/20_util/function/cons/55320.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,46 @@
+// Copyright (C) 2012 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// libstdc++/55320
+
+// { dg-options "-std=gnu++0x" }
+
+#include <functional>
+#include <testsuite_hooks.h>
+
+struct X
+{
+  X() { ++count; }
+  X(const X&) { throw 1; }
+  ~X() { --count; }
+  void operator()() { }
+  static int count;
+};
+
+int X::count = 0;
+
+int main()
+{
+  try
+  {
+    std::function<void()> f = X();
+  }
+  catch (int)
+  {
+    VERIFY( X::count == 0 );
+  }
+}
Index: libstdc++-v3/testsuite/20_util/function/cons/addressof.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/function/cons/addressof.cc	(.../tags/gcc_4_7_2_release)	(wersja 0)
+++ libstdc++-v3/testsuite/20_util/function/cons/addressof.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -0,0 +1,41 @@
+// Copyright (C) 2012 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++0x" }
+// { dg-do compile }
+
+#include <functional>
+
+struct F
+{
+  void operator()() { }
+  void operator&() const { }
+};
+
+void test01()
+{
+  F f;
+  std::function<void()> f1 = f;
+  std::function<void()> f2 = std::ref(f);
+}
+
+int main()
+{
+  test01();
+
+  return 0;
+}
Index: libstdc++-v3/testsuite/20_util/bind/ref_neg.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/bind/ref_neg.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/20_util/bind/ref_neg.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,4 +1,4 @@
-// Copyright (C) 2010, 2011 Free Software Foundation, Inc.
+// Copyright (C) 2010, 2011, 2012 Free Software Foundation, Inc.
 //
 // This file is part of the GNU ISO C++ Library.  This library is free
 // software; you can redistribute it and/or modify it under the
@@ -15,7 +15,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 20.7.11 Function template bind
+// 20.8.9 Function template bind
 
 // { dg-do compile }
 // { dg-options "-std=gnu++0x" }
Index: libstdc++-v3/testsuite/20_util/specialized_algorithms/uninitialized_copy_n/move_iterators/1.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/specialized_algorithms/uninitialized_copy_n/move_iterators/1.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/20_util/specialized_algorithms/uninitialized_copy_n/move_iterators/1.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -11,7 +11,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/testsuite/20_util/specialized_algorithms/uninitialized_copy/move_iterators/1.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/specialized_algorithms/uninitialized_copy/move_iterators/1.cc	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/testsuite/20_util/specialized_algorithms/uninitialized_copy/move_iterators/1.cc	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -9,7 +9,7 @@
 // any later version.
 
 // This library is distributed in the hope that it will be useful,
-// but WITHOUT ANY WARRANTY; without Pred the implied warranty of
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU General Public License for more details.
 
Index: libstdc++-v3/config/abi/pre/gnu-versioned-namespace.ver
===================================================================
--- libstdc++-v3/config/abi/pre/gnu-versioned-namespace.ver	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/config/abi/pre/gnu-versioned-namespace.ver	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -131,6 +131,14 @@
     _ZNK11__gnu_debug16_Error_formatter8_M_error*;
     _ZNK11__gnu_debug16_Error_formatter17_M_get_max_lengthEv;
 
+    # __gnu_debug::_Safe_unordered_container_base
+    # __gnu_debug::_Safe_local_iterator_base
+    _ZN11__gnu_debug30_Safe_unordered_container_base7_M_swapERS0_;
+    _ZN11__gnu_debug30_Safe_unordered_container_base13_M_detach_allEv;
+    _ZN11__gnu_debug25_Safe_local_iterator_base9_M_attachEPNS_19_Safe_sequence_baseEb;
+    _ZN11__gnu_debug25_Safe_local_iterator_base9_M_detachEv;
+
+
     # parallel mode
     _ZN14__gnu_parallel9_Settings3getEv;
     _ZN14__gnu_parallel9_Settings3setERS0_;
Index: libstdc++-v3/Makefile.am
===================================================================
--- libstdc++-v3/Makefile.am	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libstdc++-v3/Makefile.am	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -152,8 +152,6 @@
 	"LIBCFLAGS_FOR_TARGET=$(LIBCFLAGS_FOR_TARGET)" \
 	"MAKE=$(MAKE)" \
 	"MAKEINFO=$(MAKEINFO) $(MAKEINFOFLAGS)" \
-	"PICFLAG=$(PICFLAG)" \
-	"PICFLAG_FOR_TARGET=$(PICFLAG_FOR_TARGET)" \
 	"SHELL=$(SHELL)" \
 	"RUNTESTFLAGS=$(RUNTESTFLAGS)" \
 	"exec_prefix=$(exec_prefix)" \
Index: boehm-gc/ChangeLog
===================================================================
--- boehm-gc/ChangeLog	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ boehm-gc/ChangeLog	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,11 @@
+2012-09-20  Jakub Jelinek  <jakub@redhat.com>
+
+	PR other/43620
+	* Makefile.am (AUTOMAKE_OPTIONS): Add no-dist.
+	* Makefile.in: Regenerated.
+	* include/Makefile.in: Regenerated.
+	* testsuite/Makefile.in: Regenerated.
+
 2012-09-20  Release Manager
 
 	* GCC 4.7.2 released.
Index: boehm-gc/Makefile.am
===================================================================
--- boehm-gc/Makefile.am	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ boehm-gc/Makefile.am	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -4,7 +4,7 @@
 ## files that should be in the distribution are not mentioned in this
 ## Makefile.am.
 
-AUTOMAKE_OPTIONS = foreign subdir-objects
+AUTOMAKE_OPTIONS = foreign subdir-objects no-dist
 ACLOCAL_AMFLAGS = -I .. -I ../config
 
 SUBDIRS = include testsuite
Index: libjava/configure.ac
===================================================================
--- libjava/configure.ac	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libjava/configure.ac	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -931,7 +931,7 @@
     # on Darwin -single_module speeds up loading of the dynamic libraries.
     extra_ldflags_libjava=-Wl,-single_module
     ;;
-arm*linux*eabi)
+arm*-*-linux*eabi*)
     # Some of the ARM unwinder code is actually in libstdc++.  We
     # could in principle replicate it in libgcj, but it's better to
     # have a dependency on libstdc++.
Index: libjava/classpath/configure.ac
===================================================================
--- libjava/classpath/configure.ac	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libjava/classpath/configure.ac	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -75,7 +75,7 @@
 AC_SUBST(CLASSPATH_CONVENIENCE)
 
 AC_PREREQ(2.64)
-AM_INIT_AUTOMAKE([1.9.0 gnu std-options tar-ustar -Wno-portability])
+AM_INIT_AUTOMAKE([1.9.0 gnu std-options tar-ustar no-dist -Wno-portability])
 AC_CONFIG_HEADERS([include/config.h])
 AC_PREFIX_DEFAULT(/usr/local/classpath)
 
Index: libjava/classpath/ChangeLog.gcj
===================================================================
--- libjava/classpath/ChangeLog.gcj	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libjava/classpath/ChangeLog.gcj	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,42 @@
+2012-09-20  Jakub Jelinek  <jakub@redhat.com>
+
+	PR other/43620
+	* configure.ac (AM_INIT_AUTOMAKE): Add no-dist.
+	* Makefile.in: Regenerated.
+	* doc/Makefile.in: Regenerated.
+	* doc/api/Makefile.in: Regenerated.
+	* examples/Makefile.in: Regenerated.
+	* external/Makefile.in: Regenerated.
+	* external/jsr166/Makefile.in: Regenerated.
+	* external/relaxngDatatype/Makefile.in: Regenerated.
+	* external/sax/Makefile.in: Regenerated.
+	* external/w3c_dom/Makefile.in: Regenerated.
+	* include/Makefile.in: Regenerated.
+	* lib/Makefile.in: Regenerated.
+	* native/Makefile.in: Regenerated.
+	* native/fdlibm/Makefile.in: Regenerated.
+	* native/jawt/Makefile.in: Regenerated.
+	* native/jni/Makefile.in: Regenerated.
+	* native/jni/classpath/Makefile.in: Regenerated.
+	* native/jni/gconf-peer/Makefile.in: Regenerated.
+	* native/jni/gstreamer-peer/Makefile.in: Regenerated.
+	* native/jni/gtk-peer/Makefile.in: Regenerated.
+	* native/jni/java-io/Makefile.in: Regenerated.
+	* native/jni/java-lang/Makefile.in: Regenerated.
+	* native/jni/java-math/Makefile.in: Regenerated.
+	* native/jni/java-net/Makefile.in: Regenerated.
+	* native/jni/java-nio/Makefile.in: Regenerated.
+	* native/jni/java-util/Makefile.in: Regenerated.
+	* native/jni/midi-alsa/Makefile.in: Regenerated.
+	* native/jni/midi-dssi/Makefile.in: Regenerated.
+	* native/jni/native-lib/Makefile.in: Regenerated.
+	* native/jni/qt-peer/Makefile.in: Regenerated.
+	* native/jni/xmlj/Makefile.in: Regenerated.
+	* native/plugin/Makefile.in: Regenerated.
+	* resource/Makefile.in: Regenerated.
+	* scripts/Makefile.in: Regenerated.
+	* tools/Makefile.in: Regenerated.
+
 2012-01-01  Jakub Jelinek  <jakub@redhat.com>
 
 	* gnu/java/rmi/registry/RegistryImpl.java (version): Update
Index: libjava/ChangeLog
===================================================================
--- libjava/ChangeLog	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libjava/ChangeLog	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,11 @@
+2012-12-18  Matthew Gretton-Dann  <matthew.gretton-dann@linaro.org>
+
+	Backport from mainline.
+	2012-10-15  Matthias Klose  <doko@ubuntu.com>
+
+	* configure.ac: Match arm*-*-linux-* for ARM Linux/GNU.
+	* configure: Regenerate.
+
 2012-09-20  Release Manager
 
 	* GCC 4.7.2 released.
Index: libgcc/config.host
===================================================================
--- libgcc/config.host	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/config.host	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -213,7 +213,7 @@
   esac
   ;;
 *-*-openbsd*)
-  tmake_file="$tmake_file t-crtstuff-pic t-libgcc-pic"
+  tmake_file="$tmake_file t-crtstuff-pic t-libgcc-pic t-eh-dw2-dip"
   case ${target_thread_file} in
     posix)
       tmake_file="$tmake_file t-openbsd-thread"
@@ -327,7 +327,7 @@
 arm*-*-linux*)			# ARM GNU/Linux with ELF
 	tmake_file="${tmake_file} arm/t-arm t-fixedpoint-gnu-prefix"
 	case ${host} in
-	arm*-*-linux-*eabi)
+	arm*-*-linux-*eabi*)
 	  tmake_file="${tmake_file} arm/t-elf arm/t-bpabi arm/t-linux-eabi t-slibgcc-libgcc"
 	  tm_file="$tm_file arm/bpabi-lib.h"
 	  unwind_header=config/arm/unwind-arm.h
@@ -693,6 +693,7 @@
  	;;
 m32r-*-rtems*)
 	tmake_file="$tmake_file m32r/t-m32r t-fdpbit"
+	extra_parts="$extra_parts crtinit.o crtfini.o"
 	;;
 m32rle-*-elf*)
 	tmake_file=t-fdpbit
@@ -891,7 +892,7 @@
 	extra_parts="$extra_parts crtbegin.o crtend.o crtbeginS.o crtendS.o crtbeginT.o ecrti.o ecrtn.o ncrti.o ncrtn.o"
 	;;
 powerpc-*-rtems*)
-	tmake_file="${tmake_file} rs6000/t-ppccomm rs6000/t-crtstuff t-crtstuff-pic t-fdpbit"
+	tmake_file="${tmake_file} rs6000/t-ppccomm rs6000/t-savresfgpr rs6000/t-crtstuff t-crtstuff-pic t-fdpbit"
 	extra_parts="$extra_parts crtbeginS.o crtendS.o crtbeginT.o ecrti.o ecrtn.o ncrti.o ncrtn.o"
 	;;
 powerpc-*-linux* | powerpc64-*-linux*)
@@ -995,7 +996,10 @@
 sh-*-rtems*)
 	tmake_file="$tmake_file sh/t-sh t-crtstuff-pic t-fdpbit"
 	extra_parts="$extra_parts crt1.o crti.o crtn.o crtbeginS.o crtendS.o \
-		$sh_ic_extra_parts $sh_opt_extra_parts"
+		libic_invalidate_array_4-100.a \
+		libic_invalidate_array_4-200.a \
+		libic_invalidate_array_4a.a \
+		libgcc-Os-4-200.a libgcc-4-300.a"
 	;;
 sh-wrs-vxworks)
 	tmake_file="$tmake_file sh/t-sh t-crtstuff-pic t-fdpbit"
@@ -1054,7 +1058,7 @@
 	extra_parts="$extra_parts crti.o crtn.o crtfastmath.o"
 	;;
 sparc64-*-rtems*)
-	tmake_file="$tmake_file sparc/t-elf t-crtfm"
+	tmake_file="$tmake_file t-crtfm"
 	extra_parts="$extra_parts crti.o crtn.o crtfastmath.o"
 	;;
 sparc-wrs-vxworks)
Index: libgcc/unwind-dw2-fde-dip.c
===================================================================
--- libgcc/unwind-dw2-fde-dip.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/unwind-dw2-fde-dip.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -33,7 +33,7 @@
 
 #include "tconfig.h"
 #include "tsystem.h"
-#ifndef inhibit_libc
+#if !defined(inhibit_libc) && !defined(__OpenBSD__)
 #include <elf.h>		/* Get DT_CONFIG.  */
 #endif
 #include "coretypes.h"
@@ -60,6 +60,12 @@
 #endif
 
 #if !defined(inhibit_libc) && defined(HAVE_LD_EH_FRAME_HDR) \
+    && defined(__OpenBSD__)
+# define ElfW(type) Elf_##type
+# define USE_PT_GNU_EH_FRAME
+#endif
+
+#if !defined(inhibit_libc) && defined(HAVE_LD_EH_FRAME_HDR) \
     && defined(TARGET_DL_ITERATE_PHDR) \
     && defined(__sun__) && defined(__svr4__)
 # define USE_PT_GNU_EH_FRAME
Index: libgcc/ChangeLog
===================================================================
--- libgcc/ChangeLog	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/ChangeLog	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,64 @@
+2012-12-18  Matthew Gretton-Dann  <matthew.gretton-dann@linaro.org
+
+	Backport from mainline.
+	2012-10-15  Matthias Klose  <doko@ubuntu.com>
+
+	* config.host: Match arm*-*-linux-* for ARM Linux/GNU.
+
+2012-12-17  Matthias Klose  <doko@ubuntu.com>
+
+	* config/arm/unwind-arm.h (__gnu_unwind_24bit): Mark parameters
+	as unused.
+	(_Unwind_decode_typeinfo_ptr): Mark base as unused.
+
+2012-12-09  Uros Bizjak  <ubizjak@gmail.com>
+
+	PR target/55344
+	* config/alpha/linux-unwind.h: Disable when inhibit_libc is defined.
+
+2012-12-04  Richard Henderson  <rth@redhat.com>
+
+	PR bootstrap/55571
+	* Makefile.in (libgcc_s.so): Depend on and link with libgcc.a.
+
+2012-11-28  Richard Henderson  <rth@redhat.com>
+
+	PR libgcc/48076
+	* emutls.c (__emutls_get_address): Avoid race condition between
+	obj->loc.offset read and emutls_key initialization.
+
+2012-11-04  Uros Bizjak  <ubizjak@gmail.com>
+
+	PR target/55175
+	* config/i386/32/sfp-machine.h: Guard exception handling and
+	rounding handling code with _SOFT_FLOAT.
+	* config/i386/64/sfp-machine.h: Ditto.
+
+2012-10-31  Joel Sherrill  <joel.sherrill@oarcorp.com>
+
+	* config.host (m32r-*-rtems*): Include crtinit.o and crtfinit.o
+	as extra_parts.
+
+2012-10-25  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config.host (sparc64-*-rtems*): Remove sparc/t-elf.
+
+2012-10-25  Ralf Corsépius <ralf.corsepius@rtems.org>
+
+	* config.host (sh*-*-rtems*): Add sh*-*-elf*'s extra_parts.
+
+2012-10-25  Sebastian Huber  <sebastian.huber@embedded-brains.de>
+
+	* config.host (powerpc-*-rtems*): Add rs6000/t-savresfgpr to
+	tmake_file.
+
+2012-10-06  Mark Kettenis  <kettenis@openbsd.org>
+
+	* config.host (*-*-openbsd*): Add t-eh-dw2-dip to tmake_file.
+	* unwind-dw2-fde-dip.c: Don't include <elf.h> on OpenBSD.
+	(USE_PT_GNU_EH_FRAME): Define for OpenBSD.
+	(ElfW): Likewise.
+
 2012-09-20  Release Manager
 
 	* GCC 4.7.2 released.
@@ -5,7 +66,7 @@
 2012-09-05  Georg-Johann Lay  <avr@gjlay.de>
 
 	Backport from 2012-09-05 mainline r190697.
-	
+
 	PR target/54461
 	* config.host (tmake_file,host=avr-*-*): Add avr/t-avrlibc if
 	configured --with-avrlibc.
Index: libgcc/config/alpha/linux-unwind.h
===================================================================
--- libgcc/config/alpha/linux-unwind.h	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/config/alpha/linux-unwind.h	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -22,6 +22,7 @@
 see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 <http://www.gnu.org/licenses/>.  */
 
+#ifndef inhibit_libc
 /* Do code reading to identify a signal frame, and set the frame
    state data appropriately.  See unwind-dw2.c for the structs.  */
 
@@ -97,3 +98,4 @@
 	  || pc[1] == 0x201f015f))	/* lda $0,NR_rt_sigreturn */
     _Unwind_SetSignalFrame (context, 1);
 }
+#endif
Index: libgcc/config/i386/32/sfp-machine.h
===================================================================
--- libgcc/config/i386/32/sfp-machine.h	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/config/i386/32/sfp-machine.h	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -107,6 +107,7 @@
     R##_c = FP_CLS_NAN;						\
   } while (0)
 
+#ifndef _SOFT_FLOAT
 #define FP_EX_INVALID		0x01
 #define FP_EX_DENORM		0x02
 #define FP_EX_DIVZERO		0x04
@@ -187,6 +188,7 @@
   } while (0)
 
 #define FP_ROUNDMODE		(_fcw & 0xc00)
+#endif
 
 #define	__LITTLE_ENDIAN	1234
 #define	__BIG_ENDIAN	4321
Index: libgcc/config/i386/64/sfp-machine.h
===================================================================
--- libgcc/config/i386/64/sfp-machine.h	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/config/i386/64/sfp-machine.h	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -49,6 +49,7 @@
     R##_c = FP_CLS_NAN;						\
   } while (0)
 
+#ifndef _SOFT_FLOAT
 #define FP_EX_INVALID		0x01
 #define FP_EX_DENORM		0x02
 #define FP_EX_DIVZERO		0x04
@@ -133,6 +134,7 @@
   } while (0)
 
 #define FP_ROUNDMODE		(_fcw & 0xc00)
+#endif
 
 #define	__LITTLE_ENDIAN	1234
 #define	__BIG_ENDIAN	4321
Index: libgcc/config/arm/unwind-arm.h
===================================================================
--- libgcc/config/arm/unwind-arm.h	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/config/arm/unwind-arm.h	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -39,7 +39,8 @@
 #endif
   /* Decode an R_ARM_TARGET2 relocation.  */
   static inline _Unwind_Word
-  _Unwind_decode_typeinfo_ptr (_Unwind_Word base, _Unwind_Word ptr)
+  _Unwind_decode_typeinfo_ptr (_Unwind_Word base __attribute__ ((unused)),
+                               _Unwind_Word ptr)
     {
       _Unwind_Word tmp;
 
@@ -65,7 +66,9 @@
     }
 
   static inline _Unwind_Reason_Code
-  __gnu_unwind_24bit (_Unwind_Context * context, _uw data, int compact)
+  __gnu_unwind_24bit (_Unwind_Context * context __attribute__ ((unused)),
+                      _uw data __attribute__ ((unused)),
+                      int compact __attribute__ ((unused)))
     {
       return _URC_FAILURE;
     }
Index: libgcc/emutls.c
===================================================================
--- libgcc/emutls.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgcc/emutls.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -136,7 +136,7 @@
 #ifndef __GTHREADS
   abort ();
 #else
-  pointer offset = obj->loc.offset;
+  pointer offset = __atomic_load_n (&obj->loc.offset, __ATOMIC_ACQUIRE);
 
   if (__builtin_expect (offset == 0, 0))
     {
@@ -147,7 +147,7 @@
       if (offset == 0)
 	{
 	  offset = ++emutls_size;
-	  obj->loc.offset = offset;
+	  __atomic_store_n (&obj->loc.offset, offset, __ATOMIC_RELEASE);
 	}
       __gthread_mutex_unlock (&emutls_mutex);
     }
Index: gcc/tree-dump.c
===================================================================
--- gcc/tree-dump.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/tree-dump.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -169,7 +169,8 @@
 dump_pointer (dump_info_p di, const char *field, void *ptr)
 {
   dump_maybe_newline (di);
-  fprintf (di->stream, "%-4s: %-8lx ", field, (unsigned long) ptr);
+  fprintf (di->stream, "%-4s: %-8" HOST_WIDE_INT_PRINT "x ", field,
+	   (unsigned HOST_WIDE_INT) (uintptr_t) ptr);
   di->column += 15;
 }
 
Index: gcc/tree-ssa-tail-merge.c
===================================================================
--- gcc/tree-ssa-tail-merge.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/tree-ssa-tail-merge.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1559,7 +1559,12 @@
 
   timevar_push (TV_TREE_TAIL_MERGE);
 
-  calculate_dominance_info (CDI_DOMINATORS);
+  if (!dom_info_available_p (CDI_DOMINATORS))
+    {
+      /* PRE can leave us with unreachable blocks, remove them now.  */
+      delete_unreachable_blocks ();
+      calculate_dominance_info (CDI_DOMINATORS);
+    }
   init_worklist ();
 
   while (!VEC_empty (same_succ, worklist))
Index: gcc/c-family/ChangeLog
===================================================================
--- gcc/c-family/ChangeLog	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/c-family/ChangeLog	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,12 @@
+2012-12-03  Marek Polacek  <polacek@redhat.com>
+
+	Backported from mainline
+	2012-12-03  Marek Polacek  <polacek@redhat.com>
+
+	PR c/55570
+	* c-common.c (check_user_alignment): Swap order of tests,
+	check TREE_CODE first.
+
 2012-09-20  Release Manager
 
 	* GCC 4.7.2 released.
Index: gcc/c-family/c-common.c
===================================================================
--- gcc/c-family/c-common.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ gcc/c-family/c-common.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -6741,8 +6741,8 @@
 {
   int i;
 
-  if (!INTEGRAL_TYPE_P (TREE_TYPE (align))
-      || TREE_CODE (align) != INTEGER_CST)
+  if (TREE_CODE (align) != INTEGER_CST
+      || !INTEGRAL_TYPE_P (TREE_TYPE (align)))
     {
       error ("requested alignment is not an integer constant");
       return -1;
